import { RSocketClient } from "../rsocket/rsocket-client";
import { Observable } from "rxjs";
import { GraphqlSubscribe, MutationDocumentNode, QueryDocumentNode, SubscriptionDocumentNode } from "./graphql.type";
export declare class GraphqlClient {
    private rSocketClient;
    private readonly route;
    constructor(rSocketClient: RSocketClient, route: string);
    query<T>(query: QueryDocumentNode<T>): Observable<T>;
    subscription<T>(subscription: SubscriptionDocumentNode<T>, initialRequestN: number): Observable<GraphqlSubscribe<T>>;
    mutation<T>(mutation: MutationDocumentNode<T>): Observable<T>;
}
